<template>
  <main class="form-signin">
    <form @submit.prevent="submit">
      <h1 class="d-flex justify-content-center h3 mb-3 fw-normal">
        Create Profile
      </h1>

      <input
        v-model="data.email"
        type="email"
        class="form-control"
        placeholder="Email"
        required
      />

      <input
        v-model="data.password"
        type="password"
        class="form-control"
        placeholder="Password"
        required
      />

      <input
        v-model="data.username"
        type="text"
        class="form-control"
        placeholder="Name"
        required
      />

      <input
        v-model="data.dob"
        type="text"
        onfocus="(this.type='date')"
        class="form-control"
        placeholder="Date of Birth"
        required
      />

      <input
        v-model="data.phone"
        type="number"
        class="form-control"
        placeholder="Phone Number"
        required
      />

      <textarea
        v-model="data.address"
        type="text"
        class="form-control"
        placeholder="Address"
        required
      />

      <button class="w-100 btn btn-lg btn-primary" type="submit">
        Register
      </button>
    </form>
  </main>
</template>

<script>
import { reactive, onBeforeMount } from "vue";
import { useRouter } from "vue-router";
import { useStore } from "vuex";

export default {
  name: "CreateProfile",
  setup() {
    const store = useStore();
    const router = useRouter();

    store.commit("setAuth", { auth: false });

    onBeforeMount(async () => {
      if (!store.state.currentEmail) {
        await router.push("/");
      }
    });

    const data = reactive({
      email: store.state.currentEmail,
      password: store.state.currentPassword,
      username: "",
      dob: "",
      phone: "",
      address: "",
    });

    const submit = async () => {
      await fetch("api/register", {
        method: "POST",
        headers: {
          "Content-Type": "application/json",
        },
        credentials: "include",
        body: JSON.stringify(data),
      });

      store.commit("setAuth", { auth: true });
      await router.push("/my-profile");
    };

    return {
      data,
      submit,
    };
  },
};
</script>

<style scoped>
input::-webkit-inner-spin-button {
  -webkit-appearance: none;
  margin: 0;
}
</style>
